#include < amxmodx >
#include < amxmisc >
#include < dhudmessage >

#define PLUGIN  "Menu Greetings"
#define VERSION "1.0"
#define AUTHOR  "OverGame"

#pragma tabsize 0

#define I_LVL ADMIN_VOTE

new gActive

new sounds[][] = 
{
    "mg/mg1.mp3",
	"mg/mg2.mp3",
	"mg/mg3.mp3",
	"mg/mg4.mp3"
}

public plugin_init()
{
    register_plugin(PLUGIN, VERSION, AUTHOR)
	
	register_clcmd("say /mg", "menu_greetings")
	register_clcmd("say_team /mg", "menu_greetings")
	register_clcmd("mg", "menu_greetings")
	
	gActive = true
}

public plugin_precache()
{
	new entries = sizeof sounds
	for( new i = 0; i < entries; i++ )
		precache_sound( sounds[i] );
}

public refresh_active(id)
{
	gActive = true
	ChatColor(id, "!t[!gПОЗДРАВЛЕНИЯ!t]!y Откат завершен! Можете поздравить игроков.")
}

public menu_greetings(id)
{
    if ( !(get_user_flags(id) & I_LVL) )
	    return PLUGIN_HANDLED

	static s_MenuItem[255]
	formatex(s_MenuItem, charsmax(s_MenuItem), "\rМеню поздравлений")
	new menu = menu_create(s_MenuItem, "mg_hand" )
 
	menu_additem(menu, "\yПоздравить всех с новым годом.", "1")
	menu_additem(menu, "\yПожелать всем счастья.", "2")
	menu_additem(menu, "\yПожелать всем здоровья.", "3")
	menu_additem(menu, "\yПожелать всем любви.", "4")
		
	menu_setprop(menu, MPROP_BACKNAME, "Назад")
	menu_setprop(menu, MPROP_NEXTNAME, "Далее")
	menu_setprop(menu, MPROP_EXITNAME, "Выход")
 
	menu_display(id,menu,0)
	return PLUGIN_HANDLED
}

public mg_hand(id, menu, item)
{
	if(item == MENU_EXIT)
	{
		menu_destroy(menu)
		return PLUGIN_HANDLED
	}
	
	if(!gActive)
	{
	    ChatColor(id, "!t[!gПОЗДРАВЛЕНИЯ!t]!y Идет откат! Обычно он идет!t 15!y секунд.")
	    menu_greetings(id)
	    return PLUGIN_HANDLED
	}
	
	new data[6], iName[64], access, callback, gMsg[255], gNum, clr_r, clr_g, clr_b
	menu_item_getinfo(menu, item, access, data, 5, iName, 63, callback)
 
	new key = str_to_num(data)
	
	gNum = random_num(1,4)
	
	switch(gNum)
	{
		case 1:
		{
			clr_r = 234
			clr_g = 70
			clr_b = 70
		}
		case 2:
		{
			clr_r = 51
			clr_g = 255
			clr_b = 153
		}
		case 3:
		{
			clr_r = 255
			clr_g = 255
			clr_b = 255
		}
		case 4:
		{
			clr_r = 255
			clr_g = 255
			clr_b = 153
		}
	}
	
	set_dhudmessage(clr_r, clr_g, clr_b, -1.0, 0.64, 0, 1.0, 15.0, 0.1, 0.1)
	
	switch(key)
	{
		case 1:
		{
			formatex(gMsg, charsmax(gMsg), "Поздравляем вас с новым годом!")
        }
		case 2:
		{
			formatex(gMsg, charsmax(gMsg), "Дорогой игрок!^nМы желаем вам^nЛучшего счастья в Новом году!")
        }
		case 3:
		{
			formatex(gMsg, charsmax(gMsg), "Дорогой игрок!^nМы желаем вам^nБольшого здоровья в Новом году!")
        }
		case 4:
		{
			formatex(gMsg, charsmax(gMsg), "Дорогой игрок!^nМы желаем вам^nЧестной любви в Новом году!")
        }
    }
	
	client_cmd(0, "mp3 stop; mp3 play sound/mg/mg%d.mp3", key)
	
	gActive = false
	set_task(15.0, "refresh_active", 0)
	show_dhudmessage(0, gMsg)
	menu_greetings(id)
	
	return PLUGIN_HANDLED
}

stock ChatColor(const id, const input[], any:...)
{
	new count = 1, players[32]
	static msg[188]
	vformat(msg, 187, input, 3)
	
	replace_all(msg, 187, "!g", "^4")
	replace_all(msg, 187, "!y", "^1")
	replace_all(msg, 187, "!t", "^3")
	
	if (id) players[0] = id; else get_players(players, count, "ch")
	{
		for (new i = 0; i < count; i++)
		{
			if (is_user_connected(players[i]))
			{
				message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("SayText"), _, players[i]);
				write_byte(players[i]);
				write_string(msg);
				message_end();
			}
		}
	}
}